/////////////////////////////////////////////////////////////////////////////
// GLOBAL_DEFS.H
/////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <Wingdi.h>

#include <d3d9.h>
#include <dxgi.h>
#include <D3dx9core.h>

// general stuff - my definitions
#define SAFERELEASE(p) if (p) {(p)->Release(); (p) = NULL;}
#define SAFEDELETE(p) if (p) {delete(p); (p) = NULL;}
#define SAFEDELETE_ARRAY(p) if (p) {delete[](p); (p) = NULL;}

#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))

#define PI 3.1415926535f

#define DEGTORAD(x) ((x) * PI / 180.0f)
#define RADTODEG(x) ((x) * 180.0f / PI)

// Overloaded Debug functions. CarriageReturn must be given by caller !
inline void DB(wchar_t* pInfo, float fVal)
{
    //#ifdef _DEBUG 
    wchar_t buffer[MAX_PATH];
    swprintf_s(buffer,MAX_PATH,L"%s %.3f",pInfo,fVal);
    OutputDebugString(buffer);
    //#endif
}

inline void DB(wchar_t* pInfo, int iVal)
{
    //#ifdef _DEBUG 
	wchar_t buffer[MAX_PATH];
    swprintf_s(buffer,MAX_PATH,L"%s %i",pInfo,iVal);
    OutputDebugString(buffer);
    //#endif
}

inline void DB(wchar_t* pInfo)
{
    //#ifdef _DEBUG 
    OutputDebugString(pInfo);
    //#endif
}

// File Version. Resource (version) must be changed, too !
#define GP_DLLVERSION 1.8
#define GP_COMMSVERSION 1.8
#define GP_SINGLELINE_LENGHT 128
#define GP_MULTILINE_LENGHT 512
#define GP_CONTROL_MFF_NAME L"gp1mmf"
#define GP_PICDATA_MFF_NAME L"gp2mmf"

// sub-struct for more than one ingame textlines
struct SL_BLOBstruct
{
	// Single Line Text Functions
    BYTE            cSL_ShowIt;
    WORD            wSL_TextPosX;
    WORD            wSL_TextPosY;
    BYTE            cSL_TextSize;
    BYTE            cSL_TextBold;
    D3DCOLOR        sSL_TextColor;
    BYTE            cSL_FontFamily;
    BYTE            cSL_TextBlackBackground;
	wchar_t         cSL_LineData[GP_SINGLELINE_LENGHT];
};

struct ML_BLOBstruct
{
	// Multiline Text Functions
    BYTE            cML_ShowIt;
    WORD            wML_PosX;
    WORD            wML_PosY;
    D3DCOLOR        dwML_TextColor;
    BYTE            cML_BlackBackground;
    WORD            wML_SizeX;
    WORD            wML_SizeY;
    BYTE            cML_FontSize;
	BYTE            cML_TextBold;
    BYTE            cML_FontFamily;
	wchar_t         cML_LineData[GP_MULTILINE_LENGHT];
};


#define GP_NUMBER_OF_SINGLE_LINE_FIELDS 10
#define GP_NUMBER_OF_MULTI_LINES_FIELDS 5
#define GP_MAX_PATHLENGTH 128

// The control MMF layout
struct CONTROLMMFstruct
{
    // Single Line Text Functions
	SL_BLOBstruct SL_Data[GP_NUMBER_OF_SINGLE_LINE_FIELDS];

	// Multiline Text Functions
	ML_BLOBstruct ML_Data[GP_NUMBER_OF_MULTI_LINES_FIELDS];

	// Picture(from Disk) functions
    BYTE            cPIC_ShowIt;
    BYTE            cPIC_LoadNew;
    WORD            wPIC_PosX;
    WORD            wPIC_PosY;
	wchar_t         cPathToPicture[GP_MAX_PATHLENGTH];

	// Picture (from internal memory) functions
	BYTE            cPIC_IM_ShowIt;
	UINT			uPIC_IM_ByteSize;
	BYTE            cPIC_IM_LoadNew;
	WORD            wPIC_IM_PosX;
	WORD            wPIC_IM_PosY;
	
	// Screensize Info Function
	UINT            cSI_iScreenX;
	UINT            cSI_iScreenY;

	// FPS on/off switch
	BYTE            bSI_ShowFPS;

	// Screeshot Functions
	BYTE            bSS_DoScreenshot;
	BYTE            bSS_ScreenshotFormat; //0=bmp,1=jpg
	wchar_t         cPathToScreenshot[GP_MAX_PATHLENGTH];

};
