#include "StdAfx.h"
#include "gpcomms.h"

/* ********************************************************************************* */
CGPComms::CGPComms(void)
/* ********************************************************************************* */
{
    m_hMMFcontrolVIEW = NULL;
	m_hMMFcontrolFILE = NULL;
}

/* ********************************************************************************* */
CGPComms::~CGPComms(void)
/* ********************************************************************************* */
{
    ReleaseAllMMF();
}

/* ********************************************************************************* */
void CGPComms::ReleaseAllMMF(void)
/* ********************************************************************************* */
{
	ReleaseControlMMF();
	ReleasePicDataMMF();
}

/* ********************************************************************************* */
void CGPComms::ReleaseControlMMF(void)
/* ********************************************************************************* */
{
	if (m_hMMFcontrolVIEW) UnmapViewOfFile(m_hMMFcontrolVIEW);
	m_hMMFcontrolVIEW = NULL;

	if (m_hMMFcontrolFILE) CloseHandle(m_hMMFcontrolFILE);
	m_hMMFcontrolFILE = NULL;
}

/* ********************************************************************************* */
void CGPComms::ReleasePicDataMMF(void)
/* ********************************************************************************* */
{
	if (m_hMMFpicdataVIEW) UnmapViewOfFile(m_hMMFpicdataVIEW);
	m_hMMFpicdataVIEW = NULL;

	if (m_hMMFpicdataFILE) CloseHandle(m_hMMFpicdataFILE);
	m_hMMFpicdataFILE = NULL;
}

/* ********************************************************************************* */
bool CGPComms::CheckForControlMMF(void)
/* ********************************************************************************* */
{
    if (m_hMMFcontrolVIEW) return(true);

    // Try to access the control MMF
	m_hMMFcontrolFILE = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, GP_CONTROL_MFF_NAME);
    if (m_hMMFcontrolFILE == NULL) return(false); 
	
    // Set a view on control info
	m_hMMFcontrolVIEW = MapViewOfFile( m_hMMFcontrolFILE,FILE_MAP_ALL_ACCESS,0,0,0);
	if (m_hMMFcontrolVIEW == NULL) 
	{
		// reset control file pointer
		CloseHandle(m_hMMFcontrolFILE); 
        m_hMMFcontrolFILE = NULL;
		return(false);
	}
	
	DB(L"GPROXY: Control MMF opened.\r\n");
    
    return(true);
}

/* ********************************************************************************* */
bool CGPComms::CheckForPicDataMMF(void)
/* ********************************************************************************* */
{
	if (m_hMMFpicdataVIEW) return(true);

	// Try to access the picdata MMF
	m_hMMFpicdataFILE = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, GP_PICDATA_MFF_NAME);
	if (m_hMMFpicdataFILE == NULL) return(false);

	// Set a view on control info
	m_hMMFpicdataVIEW = MapViewOfFile(m_hMMFpicdataFILE, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if (m_hMMFpicdataVIEW == NULL)
	{
		// reset control file pointer
		CloseHandle(m_hMMFpicdataFILE);
		m_hMMFpicdataFILE = NULL;
		return(false);
	}

	return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SL_GetShowText(BYTE cObjectNumber)
/* ********************************************************************************* */
{
	if ((cObjectNumber<0) || (cObjectNumber>(GP_NUMBER_OF_SINGLE_LINE_FIELDS - 1))) return(false);
	    
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    return(pControl->SL_Data[cObjectNumber].cSL_ShowIt != 0);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SL_GetTextLineData(BYTE cObjectNumber,
									  WORD& wTextPosX, WORD& wTextPosY, 
                                      LPCWSTR& pTextLine, D3DCOLOR& dwTextColor,
                                      bool& bBlackBackground, BYTE& cSize,
                                      bool& bTextBold, BYTE& cFontFamily)
/* ********************************************************************************* */
{
	if ((cObjectNumber<0) || (cObjectNumber>(GP_NUMBER_OF_SINGLE_LINE_FIELDS - 1))) return(false);

    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
    pTextLine        = (LPCWSTR) pControl->SL_Data[cObjectNumber].cSL_LineData;
	wTextPosX		 = pControl->SL_Data[cObjectNumber].wSL_TextPosX;
    wTextPosY		 = pControl->SL_Data[cObjectNumber].wSL_TextPosY;
    dwTextColor      =  pControl->SL_Data[cObjectNumber].sSL_TextColor;
    bBlackBackground =  (pControl->SL_Data[cObjectNumber].cSL_TextBlackBackground != 0);
    cSize            =  pControl->SL_Data[cObjectNumber].cSL_TextSize;
    bTextBold        =  (pControl->SL_Data[cObjectNumber].cSL_TextBold != 0);
    cFontFamily      = (!pControl->SL_Data[cObjectNumber].cSL_FontFamily?FF_SWISS:FF_MODERN);

	return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_ML_GetShowText(BYTE cObjectNumber)
/* ********************************************************************************* */
{
	if ((cObjectNumber<0) || (cObjectNumber>(GP_NUMBER_OF_MULTI_LINES_FIELDS - 1))) return(false);
    
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
    return(pControl->ML_Data[cObjectNumber].cML_ShowIt != 0);
}

/* ********************************************************************************* */
bool CGPComms::MMF_ML_GetTextMultilineData(BYTE cObjectNumber,
										   WORD& wPosX, WORD& wPosY,
                                           LPCWSTR& pText, DWORD& dwTextColor,
                                           bool& bBlackBackground, BYTE& cFontSize,
                                           bool& bTextBold, WORD& wSizeX, WORD& wSizeY,
                                           BYTE& cFontFamily)
/* ********************************************************************************* */
{
	if ((cObjectNumber<0) || (cObjectNumber>(GP_NUMBER_OF_MULTI_LINES_FIELDS - 1)))  return(false);
   
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    pText			  = (LPCWSTR) pControl->ML_Data[cObjectNumber].cML_LineData;    
    wPosX             = pControl->ML_Data[cObjectNumber].wML_PosX;
    wPosY             = pControl->ML_Data[cObjectNumber].wML_PosY;
    dwTextColor       = pControl->ML_Data[cObjectNumber].dwML_TextColor;
    bBlackBackground  = (pControl->ML_Data[cObjectNumber].cML_BlackBackground!=0);
    cFontSize         = pControl->ML_Data[cObjectNumber].cML_FontSize;
	bTextBold         = (pControl->ML_Data[cObjectNumber].cML_TextBold != 0);
    wSizeX            = pControl->ML_Data[cObjectNumber].wML_SizeX;
    wSizeY            = pControl->ML_Data[cObjectNumber].wML_SizeY;
    cFontFamily       = pControl->ML_Data[cObjectNumber].cML_FontFamily; 

    return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_PIC_GetPictureNewShowPosition(WORD& wPosX, WORD& wPosY, bool& bNew, bool& bShow)
/* ********************************************************************************* */
{
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    wPosX = pControl->wPIC_PosX;
    wPosY = pControl->wPIC_PosY;
    bShow = (pControl->cPIC_ShowIt != 0);
    bNew  = (pControl->cPIC_LoadNew != 0);

    // if new requested, reset flag. we only do load once
    if (bNew) pControl->cPIC_LoadNew = 0;

    return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_PIC_GetPathToFile(LPCWSTR& pPathToFile)
/* ********************************************************************************* */
{
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    pPathToFile = (LPCWSTR) pControl->cPathToPicture;

    return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_PIC_IM_GetPictureNewShowPosition(WORD& wPosX, WORD& wPosY, bool& bNew, bool& bShow)
/* ********************************************************************************* */
{
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*)m_hMMFcontrolVIEW;

	wPosX = pControl->wPIC_IM_PosX;
	wPosY = pControl->wPIC_IM_PosY;
	bShow = (pControl->cPIC_IM_ShowIt != 0);
	bNew = (pControl->cPIC_IM_LoadNew != 0);

	return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_PIC_IM_GetPictureData(BYTE** pData, UINT* pSize)
/* ********************************************************************************* */
{
	if (!CheckForPicDataMMF()) return(false);

	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*)m_hMMFcontrolVIEW;
	*pSize = pControl->uPIC_IM_ByteSize;

	BYTE* pPicData = (BYTE*)m_hMMFpicdataVIEW;

	*pData = new BYTE[*pSize];

	// Copy all bytes to the MMF
	for (UINT i = 0; i < *pSize; i++)
	{
		(*pData)[i] = pPicData[i];
	}

	// Directly release view of the data MMF
	ReleasePicDataMMF();

	// Signal that we loaded the picture
	pControl->cPIC_IM_LoadNew = 0;

	return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SI_SetScreenSizeInfo(UINT iScreenSizeX, UINT iScreenSizeY)
/* ********************************************************************************* */
{
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

	pControl->cSI_iScreenX = iScreenSizeX;
	pControl->cSI_iScreenY = iScreenSizeY;

	return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SI_GetShowFPS(void)
/* ********************************************************************************* */
{
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
    return(pControl->bSI_ShowFPS != 0);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SS_GetMakeScreenshot()
/* ********************************************************************************* */
{
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
    return(pControl->bSS_DoScreenshot != 0);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SS_GetPathToScreenshot(LPCWSTR& pPathToScreenshot)
/* ********************************************************************************* */
{
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    pPathToScreenshot = (LPCWSTR) pControl->cPathToScreenshot;

    return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SS_ClearMakeScreenshot()
/* ********************************************************************************* */
{
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
	pControl->bSS_DoScreenshot = 0;
    
	return(true);
}

/* ********************************************************************************* */
bool CGPComms::MMF_SS_GetScreenshotFormat()
/* ********************************************************************************* */
{
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
    return(pControl->bSS_ScreenshotFormat != 0);
}
