// gp_dll.cpp : Definiert die Initialisierungsroutinen fr die DLL.
//

#include "stdafx.h"
#include "gp_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Das einzige Cgp_dllApp-Objekt
Cgp_dllApp theApp;

// Exported Functions SINGLE LINE *****************************************************
bool __stdcall GPSL_SetTextLineData(BYTE cObjectNumber,
									WORD wTextPosX, WORD wTextPosY, 
                                    LPCWSTR pTextLine, DWORD dwTextColor,
                                    bool bBlackBackground, BYTE cSize,
                                    bool bTextBold, BYTE cFontFamily)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (theApp.MMF_SL_SetTextLineData(cObjectNumber,
										  wTextPosX, wTextPosY, 
                                          pTextLine, dwTextColor,
                                          bBlackBackground, cSize,
                                          bTextBold, cFontFamily));
}

bool __stdcall GPSL_ShowText(BYTE cObjectNumber, bool bShowIt)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_SL_ShowText(cObjectNumber,bShowIt));
}

// Exported Functions MULTILINE *****************************************************
bool __stdcall GPML_SetTextMultilineData(BYTE cObjectNumber,
										 WORD wPosX, WORD wPosY,
                                         LPCWSTR pText, DWORD dwTextColor,
                                         bool bBlackBackground,BYTE cFontSize,
										 bool bTextBold,
                                         WORD wSizeX, WORD wSizeY,
                                         BYTE cFontFamily)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (theApp.MMF_ML_SetTextMultilineData(cObjectNumber,
											   wPosX, wPosY,
                                               pText, dwTextColor,
                                               bBlackBackground, cFontSize,
											   bTextBold,
                                               wSizeX, wSizeY,
                                               cFontFamily));
}


bool __stdcall GPML_ShowText(BYTE cObjectNumber, bool bShowIt)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_ML_ShowText(cObjectNumber, bShowIt));
}

// Exported Functions PICTURE *****************************************************
bool __stdcall GPPIC_LoadNewPicture(LPCWSTR sPathToFile)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_PIC_LoadNewPicture(sPathToFile));
}

bool __stdcall GPPIC_ShowPicturePos(bool bShowIt, WORD wPosX, WORD wPosY)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_PIC_ShowPicturePos(bShowIt, wPosX, wPosY));
}

// Exported Function ScreenInfo *****************************************************
bool __stdcall GPSI_GetScreenSize(int& piScreenX, int& piScreenY)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_SI_GetScreenSize(piScreenX,piScreenY));
}

// Exported Function ShowFPS *****************************************************
bool __stdcall GPSI_ShowFPS(bool bShow)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_SI_ShowFPS(bShow));
}

// Exported Function MakeScreenshot *****************************************************
bool __stdcall GPSS_MakeScreenshot(bool bFormat, LPCWSTR sPathToScreenshot)
{
    //bFormat: 0=bmp, 1=jpg;
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return(theApp.MMF_SS_MakeScreenshot(bFormat, sPathToScreenshot));
}

// Exported Functions PICTURE INTERNAL *****************************************************
bool __stdcall GPPICI_LoadNewInternalPicture(BYTE* pData, UINT uiDataSize)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return(theApp.MMF_PIC_IM_LoadNewInternalPicture(pData, uiDataSize));
}

bool __stdcall GPPICI_ShowInternalPicturePos(bool bShowIt, WORD wPosX, WORD wPosY)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return(theApp.MMF_PIC_IM_ShowInternalPicturePos(bShowIt, wPosX, wPosY));
}

// Cgp_dllApp

BEGIN_MESSAGE_MAP(Cgp_dllApp, CWinApp)
END_MESSAGE_MAP()


// Cgp_dllApp-Erstellung

Cgp_dllApp::Cgp_dllApp()
{
	m_hMMFcontrolVIEW = NULL;
	m_hMMFcontrolFILE = NULL;

	m_hMMFpicdataVIEW = NULL;
	m_hMMFpicdataFILE = NULL;
}

// Cgp_dllApp Initialisierung
BOOL Cgp_dllApp::InitInstance()
{
	CWinApp::InitInstance();

#if defined _M_IX86
	DB(L"GPCOMMS: InitInstance called. Version ", (float)GP_DLLVERSION);
#else
	DB(L"GPCOMMS_64: InitInstance called. Version ",(float)GP_DLLVERSION);
#endif

	return(true);
}

int Cgp_dllApp::ExitInstance()
{
    DB(L"GPCOMMS: ExitInstance called.\r\n");
    
    // clear all comm channels
    ClearControlMMF();
    
    RemoveControlMMF();
	RemovePicdataMMF();

    return CWinApp::ExitInstance();
}

void Cgp_dllApp::ClearControlMMF(void)
{
    if (m_hMMFcontrolVIEW) 
    {
		byte* bP = (byte*) m_hMMFcontrolVIEW;
		memset(bP,0,sizeof(CONTROLMMFstruct));
    }
}

void Cgp_dllApp::RemoveControlMMF()
{
	// release own views of MMF: CONTROL MMF
	if (m_hMMFcontrolVIEW)
	{
		UnmapViewOfFile(m_hMMFcontrolVIEW);
		m_hMMFcontrolVIEW = NULL;
	}

	if (m_hMMFcontrolFILE)
	{
		CloseHandle(m_hMMFcontrolFILE);
		m_hMMFcontrolFILE = NULL;
	}
}

void Cgp_dllApp::RemovePicdataMMF()
{
	// release own views of MMF: PICDATA MMF
	if (m_hMMFpicdataVIEW)
	{
		UnmapViewOfFile(m_hMMFpicdataVIEW);
		m_hMMFpicdataVIEW = NULL;
	}

	if (m_hMMFpicdataFILE)
	{
		CloseHandle(m_hMMFpicdataFILE);
		m_hMMFpicdataFILE = NULL;
	}
}

bool Cgp_dllApp::CheckForControlMMF(void)
{
    if (m_hMMFcontrolVIEW) return(true); 
    
    // Try to create the control MMF. Always done by gpcomms. d3d8 listening
	m_hMMFcontrolFILE = CreateFileMapping(
											INVALID_HANDLE_VALUE, 
											NULL,
											PAGE_READWRITE,
											0,
											sizeof(CONTROLMMFstruct),
											GP_CONTROL_MFF_NAME
										 );
	
	if (!m_hMMFcontrolFILE)	
    {
		DB(L"GPCOMMS: Control MMF file ERROR ***.\r\n");
		return(false); 
    }

    // Set a view on data
	m_hMMFcontrolVIEW = MapViewOfFile( m_hMMFcontrolFILE,FILE_MAP_ALL_ACCESS,0,0,0);
	if (!m_hMMFcontrolVIEW) 
    {
		DB(L"GPCOMMS: Control MMF view ERROR ***.\r\n");
		if (m_hMMFcontrolFILE) CloseHandle(m_hMMFcontrolFILE);
		m_hMMFcontrolFILE = NULL;
		return(false);	
    }

	ClearControlMMF();
    
    return(true);
}

bool Cgp_dllApp::CheckForPicdataMMF(UINT uiByteSize)
{
	// Clear older data file if still present
	if (m_hMMFpicdataVIEW) RemovePicdataMMF();

	// Try to create the picdata MMF. Always done by gpcomms. d3d8 listening.
	// The MFF will only be used once for data transfer, then released again
	// This is due to different possible size of data
	m_hMMFpicdataFILE = CreateFileMapping(
		INVALID_HANDLE_VALUE,
		NULL,
		PAGE_READWRITE,
		0,
		uiByteSize,
		GP_PICDATA_MFF_NAME
		);

	if (!m_hMMFpicdataFILE)
	{
		DB(L"GPCOMMS: picdata MMF file ERROR ***.\r\n");
		return(false);
	}

	// Set a view on data
	m_hMMFpicdataVIEW = MapViewOfFile(m_hMMFpicdataFILE, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if (!m_hMMFpicdataVIEW)
	{
		DB(L"GPCOMMS: Picdata MMF view ERROR ***.\r\n");
		if (m_hMMFpicdataFILE) CloseHandle(m_hMMFpicdataFILE);
		m_hMMFpicdataFILE = NULL;
		return(false);
	}

	return(true);
}

bool Cgp_dllApp::MMF_SL_SetTextLineData(BYTE cObjectNumber,
										WORD wTextPosX, WORD wTextPosY, 
                                        LPCWSTR pTextLine, DWORD dwTextColor,
                                        bool bBlackBackground, BYTE cSize,
                                        bool bTextBold, BYTE cFontFamily)
{
	if (!CheckForControlMMF()) return(false);
 
    // Rough Security Checks
    if (!DataCheck_FontFamily(cFontFamily)) return(false);
    if (!DataCheck_Position(wTextPosX,wTextPosY)) return(false);

    // look at the MMF
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    // Text position
    pControl->SL_Data[cObjectNumber].wSL_TextPosX			 = wTextPosX;
    pControl->SL_Data[cObjectNumber].wSL_TextPosY			 = wTextPosY;
    pControl->SL_Data[cObjectNumber].sSL_TextColor			 = dwTextColor;
    pControl->SL_Data[cObjectNumber].cSL_TextBlackBackground = (bBlackBackground?1:0);
    pControl->SL_Data[cObjectNumber].cSL_TextSize			 = cSize;
    pControl->SL_Data[cObjectNumber].cSL_TextBold			 = (bTextBold?1:0);
    pControl->SL_Data[cObjectNumber].cSL_FontFamily			 = cFontFamily;
    
	// clear text
	wmemset(pControl->SL_Data[cObjectNumber].cSL_LineData, 0, GP_SINGLELINE_LENGHT);

    // The single line text
    int i=0;
	while ((i<GP_SINGLELINE_LENGHT-1) && (pTextLine[i] != '\0'))
    {
        pControl->SL_Data[cObjectNumber].cSL_LineData[i] = pTextLine[i]; 
        i++;
    }

    return(true);   
}

bool Cgp_dllApp::MMF_SL_ShowText(BYTE cObjectNumber, bool bShowIt)
{
    if (!CheckForControlMMF()) return(false);
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
    
    pControl->SL_Data[cObjectNumber].cSL_ShowIt = (bShowIt?1:0);
    
    return(true);
}

bool Cgp_dllApp::MMF_ML_SetTextMultilineData(BYTE cObjectNumber,
											 WORD wPosX, WORD wPosY,
                                             LPCWSTR pText, DWORD dwTextColor,
                                             bool bBlackBackground, BYTE cFontSize,
                                             bool bTextBold, WORD wSizeX, WORD wSizeY,
                                             BYTE cFontFamily)
{
    if (!CheckForControlMMF())  return(false);
   
    // Rough Security Checks
    if (!DataCheck_FontFamily(cFontFamily)) return(false);
    if (!DataCheck_Position(wPosX,wPosY)) return(false);
   
    // look at the MMF as a string
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
   
    pControl->ML_Data[cObjectNumber].wML_PosX            = wPosX;
    pControl->ML_Data[cObjectNumber].wML_PosY            = wPosY;
    pControl->ML_Data[cObjectNumber].dwML_TextColor      = dwTextColor;
    pControl->ML_Data[cObjectNumber].cML_BlackBackground = (bBlackBackground?1:0);
    pControl->ML_Data[cObjectNumber].wML_SizeX           = wSizeX;
    pControl->ML_Data[cObjectNumber].wML_SizeY           = wSizeY;
    pControl->ML_Data[cObjectNumber].cML_FontFamily      = cFontFamily; 
    pControl->ML_Data[cObjectNumber].cML_FontSize        = cFontSize;
	pControl->ML_Data[cObjectNumber].cML_TextBold		 = (bTextBold?1:0);

	// clear text
	wmemset(pControl->ML_Data[cObjectNumber].cML_LineData, 0, GP_MULTILINE_LENGHT);

    // The multiline text
    int i=0;
	while ((i<GP_MULTILINE_LENGHT-1) && (pText[i] != '\0'))
    {
        pControl->ML_Data[cObjectNumber].cML_LineData[i] = pText[i]; 
        i++;
    }

	return(true);
}

bool Cgp_dllApp::MMF_ML_ShowText(BYTE cObjectNumber, bool bShowIt)
{
    if (!CheckForControlMMF()) return(false);
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    pControl->ML_Data[cObjectNumber].cML_ShowIt  = (bShowIt?1:0);
    
    return(true);
}

bool Cgp_dllApp::DataCheck_FontFamily(BYTE cFontFamily)
{
    if ((cFontFamily != 0) && (cFontFamily != 1)) return(false);
    return(true);
}

bool Cgp_dllApp::DataCheck_Position(WORD wPosX, WORD wPosY)
{
    if (wPosX > ::GetSystemMetrics(SM_CXSCREEN)) return(false);
    if (wPosY > ::GetSystemMetrics(SM_CYSCREEN)) return(false);
    
    return(true);
}

bool Cgp_dllApp::MMF_PIC_ShowPicturePos(bool bShowIt, WORD wPosX, WORD wPosY)
{
    if (!CheckForControlMMF())  return(false);
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;

    pControl->cPIC_ShowIt  = (bShowIt?1:0);
    
    pControl->wPIC_PosX    = wPosX;
    pControl->wPIC_PosY    = wPosY;
    
    return(true);
}

bool Cgp_dllApp::MMF_PIC_LoadNewPicture(LPCWSTR sPathToFile)
{
    if (!CheckForControlMMF())  return(false);
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
 
    // clear path to picture
	wmemset(pControl->cPathToPicture, 0, GP_MAX_PATHLENGTH);

    // now transfer pathname to mmf
    int i=0;
	while ((i<(GP_MAX_PATHLENGTH-1)) && (sPathToFile[i] != '\0')) 
    {
        pControl->cPathToPicture[i] = sPathToFile[i]; 
        i++;
    }
   
    // set the "load new" flag. Will be reset by d3d8/d3d9.dll
    pControl->cPIC_LoadNew = 1;

    return(true);
}

bool Cgp_dllApp::MMF_PIC_IM_ShowInternalPicturePos(bool bShowIt, WORD wPosX, WORD wPosY)
{
	if (!CheckForControlMMF())  return(false);
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*)m_hMMFcontrolVIEW;

	pControl->cPIC_IM_ShowIt = (bShowIt ? 1 : 0);

	pControl->wPIC_IM_PosX = wPosX;
	pControl->wPIC_IM_PosY = wPosY;

	return(true);
}

bool Cgp_dllApp::MMF_PIC_IM_LoadNewInternalPicture(BYTE* pData, UINT uiDataSize)
{
	if (!CheckForControlMMF())  return(false);
	CONTROLMMFstruct* pControl = (CONTROLMMFstruct*)m_hMMFcontrolVIEW;

	// Check if older transfer still pending. Then, do nothing
	if (pControl->cPIC_IM_LoadNew == 1) return(false);

	if (!CheckForPicdataMMF(uiDataSize))  return(false);
	BYTE* pPicData = (BYTE*)m_hMMFpicdataVIEW;

	// Copy all bytes to the MMF
	for (UINT i = 0; i < uiDataSize; i++)
	{
		pPicData[i] = pData[i];
	}

	// set the "load new" flag. Will be reset by d3d8/d3d9.dll
	pControl->uPIC_IM_ByteSize = uiDataSize;
	pControl->cPIC_IM_LoadNew = 1;

	return(true);
}

bool Cgp_dllApp::MMF_SI_GetScreenSize(int& piScreenX, int& piScreenY)
{
	if (!CheckForControlMMF())
	{
		piScreenX = 0;
	    piScreenY = 0;
		return(false);
	}  
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
 
    piScreenX = (int)pControl->cSI_iScreenX;
	piScreenY = (int)pControl->cSI_iScreenY;

    return(true);
}

bool Cgp_dllApp::MMF_SI_ShowFPS(bool bShowIt)
{
	if (!CheckForControlMMF())
	{		
		return(false);
	}  
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
 
    pControl->bSI_ShowFPS = (bShowIt?1:0);

    return(true);
}

bool Cgp_dllApp::MMF_SS_MakeScreenshot(bool bFormat,LPCWSTR sPathToScreenshot)
{
	if (!CheckForControlMMF())  return(false);
    CONTROLMMFstruct* pControl = (CONTROLMMFstruct*) m_hMMFcontrolVIEW;
 
    // to avoid race conditions, check for pending screeny request. abort, if so
	if (pControl->bSS_DoScreenshot == 1) return (false);	
	
	// clear path to picture
	wmemset(pControl->cPathToScreenshot, 0, GP_MAX_PATHLENGTH);

    // now transfer pathname to mmf
    int i=0;
	while ((i<(GP_MAX_PATHLENGTH-1)) && (sPathToScreenshot[i] != '\0')) 
    {
        pControl->cPathToScreenshot[i] = sPathToScreenshot[i]; 
        i++;
    }
   
    if (bFormat) pControl->bSS_ScreenshotFormat = 1;
	else pControl->bSS_ScreenshotFormat = 0;

    pControl->bSS_DoScreenshot = 1;

	return(true);
}



